Open CASCADE Technology: Draft_Modification Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
Draft_Modification Class Reference

`#include <Draft_Modification.hxx>`

Inheritance diagram for Draft_Modification:
[legend]

## Public Member Functions
| Draft_Modification (const TopoDS_Shape &S)
void | Clear ()
| Resets on the same shape. More...
void | Init (const TopoDS_Shape &S)
| Changes the basis shape and resets. More...
Standard_Boolean | Add (const TopoDS_Face &F, const gp_Dir &Direction, const Standard_Real Angle, const gp_Pln &NeutralPlane, const Standard_Boolean Flag=Standard_True)
| Adds the face F and propagates the draft modification to its neighbour faces if they are tangent. If an error occurs, will return False and ProblematicShape will return the "bad" face. More...
void | Remove (const TopoDS_Face &F)
| Removes the face F and the neighbour faces if they are tangent. It will be necessary to call this method if the method Add returns Standard_False, to unset ProblematicFace. More...
void | Perform ()
| Performs the draft angle modification and sets the value returned by the method IsDone. If an error occurs, IsDone will return Standard_False, and an error status will be given by the method Error, and the shape on which the problem appeared will be given by ProblematicShape. More...
Standard_Boolean | IsDone () const
| Returns True if Perform has been succesfully called. Otherwise more information can be obtained using the methods Error() and ProblematicShape(). More...
Draft_ErrorStatus | Error () const
const TopoDS_Shape & | ProblematicShape () const
| Returns the shape (Face, Edge or Vertex) on which an error occured. More...
const TopTools_ListOfShape & | ConnectedFaces (const TopoDS_Face &F)
| Returns all the faces which have been added together with the face <F>. More...
const TopTools_ListOfShape & | ModifiedFaces ()
| Returns all the faces on which a modification has been given. More...
Standard_Boolean | NewSurface (const TopoDS_Face &F, Handle< Geom_Surface > &S, TopLoc_Location &L, Standard_Real &Tol, Standard_Boolean &RevWires, Standard_Boolean &RevFace)
| Returns Standard_True if the face <F> has been modified. In this case, <S> is the new geometric support of the face, <L> the new location,<Tol> the new tolerance.<RevWires> has to be set to Standard_True when the modification reverses the normal of the surface.(the wires have to be reversed). <RevFace> has to be set to Standard_True if the orientation of the modified face changes in the shells which contain it. Here it will be set to Standard_False. More...
Standard_Boolean | NewCurve (const TopoDS_Edge &E, Handle< Geom_Curve > &C, TopLoc_Location &L, Standard_Real &Tol)
| Returns Standard_True if the edge <E> has been modified. In this case, `is the new geometric support of the edge, <L> the new location, <Tol> the new tolerance. Otherwise, returns Standard_False, and `, <L>, <Tol> are not significant.`` More...
Standard_Boolean | NewPoint (const TopoDS_Vertex &V, gp_Pnt &P, Standard_Real &Tol)
| Returns Standard_True if the vertex <V> has been modified. In this case,. More...
Standard_Boolean | NewCurve2d (const TopoDS_Edge &E, const TopoDS_Face &F, const TopoDS_Edge &NewE, const TopoDS_Face &NewF, Handle< Geom2d_Curve > &C, Standard_Real &Tol)
| Returns Standard_True if the edge <E> has a new curve on surface on the face <F>.In this case, `is the new geometric support of the edge, <L> the new location, <Tol> the new tolerance.` More...
Standard_Boolean | NewParameter (const TopoDS_Vertex &V, const TopoDS_Edge &E, Standard_Real &P, Standard_Real &Tol)
| Returns Standard_True if the Vertex <V> has a new parameter on the edge <E>. In this case,. More...
GeomAbs_Shape | Continuity (const TopoDS_Edge &E, const TopoDS_Face &F1, const TopoDS_Face &F2, const TopoDS_Edge &NewE, const TopoDS_Face &NewF1, const TopoDS_Face &NewF2)
| Returns the continuity of <NewE> between <NewF1> and <NewF2>. More...
Public Member Functions inherited from BRepTools_Modification
virtual Standard_Boolean | NewTriangulation (const TopoDS_Face &F, Handle< Poly_Triangulation > &T)
| Returns true if the face has been modified according to changed triangulation. If the face has been modified: More...
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Constructor & Destructor Documentation

Draft_Modification::Draft_Modification | ( | const TopoDS_Shape & | S | ) |

## Member Function Documentation

Standard_Boolean Draft_Modification::Add | ( | const TopoDS_Face & | F,
|  | const gp_Dir & | Direction,
|  | const Standard_Real | Angle,
|  | const gp_Pln & | NeutralPlane,
|  | const Standard_Boolean | Flag = `Standard_True`
| ) |  |

Adds the face F and propagates the draft modification to its neighbour faces if they are tangent. If an error occurs, will return False and ProblematicShape will return the "bad" face.

void Draft_Modification::Clear | ( |  | ) |

Resets on the same shape.

const TopTools_ListOfShape& Draft_Modification::ConnectedFaces | ( | const TopoDS_Face & | F | ) |

Returns all the faces which have been added together with the face <F>.

GeomAbs_Shape Draft_Modification::Continuity | ( | const TopoDS_Edge & | E,
|  | const TopoDS_Face & | F1,
|  | const TopoDS_Face & | F2,
|  | const TopoDS_Edge & | NewE,
|  | const TopoDS_Face & | NewF1,
|  | const TopoDS_Face & | NewF2
| ) |  |
| virtual

Returns the continuity of <NewE> between <NewF1> and <NewF2>.

<NewE> is the new edge created from <E>. <NewF1> (resp. <NewF2>) is the new face created from <F1> (resp. <F2>).

Implements BRepTools_Modification.

Draft_ErrorStatus Draft_Modification::Error | ( |  | ) | const

void Draft_Modification::Init | ( | const TopoDS_Shape & | S | ) |

Changes the basis shape and resets.

Standard_Boolean Draft_Modification::IsDone | ( |  | ) | const

Returns True if Perform has been succesfully called. Otherwise more information can be obtained using the methods Error() and ProblematicShape().

const TopTools_ListOfShape& Draft_Modification::ModifiedFaces | ( |  | ) |

Returns all the faces on which a modification has been given.

Standard_Boolean Draft_Modification::NewCurve | ( | const TopoDS_Edge & | E,
|  | Handle< Geom_Curve > & | C,
|  | TopLoc_Location & | L,
|  | Standard_Real & | Tol
| ) |  |
| virtual

Returns Standard_True if the edge <E> has been modified. In this case, `is the new geometric support of the edge, <L> the new location, <Tol> the new tolerance. Otherwise, returns Standard_False, and `, <L>, <Tol> are not significant.``

Implements BRepTools_Modification.

Standard_Boolean Draft_Modification::NewCurve2d | ( | const TopoDS_Edge & | E,
|  | const TopoDS_Face & | F,
|  | const TopoDS_Edge & | NewE,
|  | const TopoDS_Face & | NewF,
|  | Handle< Geom2d_Curve > & | C,
|  | Standard_Real & | Tol
| ) |  |
| virtual

Returns Standard_True if the edge <E> has a new curve on surface on the face <F>.In this case, `is the new geometric support of the edge, <L> the new location, <Tol> the new tolerance.`

Otherwise, returns Standard_False, and `, <L>, <Tol> are not significant.`

`<NewE> is the new edge created from <E>. <NewF> is the new face created from <F>. They may be usefull.`

Implements BRepTools_Modification.

Standard_Boolean Draft_Modification::NewParameter | ( | const TopoDS_Vertex & | V,
|  | const TopoDS_Edge & | E,
|  | Standard_Real & | P,
|  | Standard_Real & | Tol
| ) |  |
| virtual

Returns Standard_True if the Vertex <V> has a new parameter on the edge <E>. In this case,.

is the parameter, <Tol> the new tolerance. Otherwise, returns Standard_False, and

, <Tol> are not significant.

Implements BRepTools_Modification.

Standard_Boolean Draft_Modification::NewPoint | ( | const TopoDS_Vertex & | V,
|  | gp_Pnt & | P,
|  | Standard_Real & | Tol
| ) |  |
| virtual

Returns Standard_True if the vertex <V> has been modified. In this case,.

is the new geometric support of the vertex, <Tol> the new tolerance. Otherwise, returns Standard_False, and

, <Tol> are not significant.

Implements BRepTools_Modification.

Standard_Boolean Draft_Modification::NewSurface | ( | const TopoDS_Face & | F,
|  | Handle< Geom_Surface > & | S,
|  | TopLoc_Location & | L,
|  | Standard_Real & | Tol,
|  | Standard_Boolean & | RevWires,
|  | Standard_Boolean & | RevFace
| ) |  |
| virtual

Returns Standard_True if the face <F> has been modified. In this case, <S> is the new geometric support of the face, <L> the new location,<Tol> the new tolerance.<RevWires> has to be set to Standard_True when the modification reverses the normal of the surface.(the wires have to be reversed). <RevFace> has to be set to Standard_True if the orientation of the modified face changes in the shells which contain it. Here it will be set to Standard_False.

Otherwise, returns Standard_False, and <S>, <L>, <Tol> , <RevWires> ,<RevFace> are not significant.

Implements BRepTools_Modification.

void Draft_Modification::Perform | ( |  | ) |

Performs the draft angle modification and sets the value returned by the method IsDone. If an error occurs, IsDone will return Standard_False, and an error status will be given by the method Error, and the shape on which the problem appeared will be given by ProblematicShape.

const TopoDS_Shape& Draft_Modification::ProblematicShape | ( |  | ) | const

Returns the shape (Face, Edge or Vertex) on which an error occured.

void Draft_Modification::Remove | ( | const TopoDS_Face & | F | ) |

Removes the face F and the neighbour faces if they are tangent. It will be necessary to call this method if the method Add returns Standard_False, to unset ProblematicFace.

The documentation for this class was generated from the following file:

- Draft_Modification.hxx